## python-parsl 2025.11.17+ds

=== Makefile ===
PYTHON := $(shell which python3 || echo ".python_is_missing")
SHELL := $(shell which bash) # Use bash instead of bin/sh as shell
GIT := $(shell which git || echo ".git_is_missing")
CWD := $(shell pwd)
DEPS := .deps
MPICH=mpich
OPENMPI=openmpi
export HYDRA_LAUNCHER=fork
export OMPI_MCA_rmaps_base_oversubscribe=yes
MPI=$(MPICH)

.PHONY: help
help: ## me
	@grep -E '^[0-9a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | sort | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-30s\033[0m %s\n", $$1, $$2}'

VENV = .venv
.PHONY: virtualenv
virtualenv: ## create an activate a virtual env
	test -f $(VENV)/bin/activate || $(PYTHON) -m venv $(VENV)
	echo "Run 'source $(VENV)/bin/activate' to activate the virtual environment"


$(DEPS): test-requirements.txt requirements.txt
	pip3 install --upgrade pip
	pip3 install -r test-requirements.txt -r requirements.txt
	touch $(DEPS)

.PHONY: deps
deps: $(DEPS) ## install the dependencies

.PHONY: lint
lint: ## run linter script
	parsl/tests/lint-inits.sh

.PHONY: isort
isort: ## run isort on all files
	isort --check parsl/

.PHONY: flake8
flake8:  ## run flake
	flake8 parsl/

.PHONY: clean_coverage
clean_coverage:  ## clear the coverage file (.coverage)
	rm -f .coverage

.PHONY: mypy
mypy: ## run mypy checks
	MYPYPATH=$(CWD)/mypy-stubs mypy parsl/

.PHONY: gce_test
gce_test: ## Run tests with GlobusComputeExecutor (--config .../globus_compute.py)
	pytest -v -k "not shared_fs and not issue_3620 and not staging_required" --config parsl/tests/configs/globus_compute.py parsl/tests/ --random-order --durations 10
	pytest -v -k "not shared_fs and not issue_3620 and not staging_required and globus_compute" --config local --random-order --durations 10

.PHONY: local_thread_test
local_thread_test: ## run all tests with local_thread config (--config .../local_threads.py)
	pytest parsl/tests/ -k "not cleannet" --config parsl/tests/configs/local_threads.py --random-order --durations 10

.PHONY: htex_local_test
htex_local_test: ## run all tests with htex_local config (--config .../htex_local.py)
	pip3 install .
	pytest parsl/tests/ -k "not cleannet" --config parsl/tests/configs/htex_local.py --random-order --durations 10

.PHONY: htex_local_alternate_test
htex_local_alternate_test: ## run all tests with htex_local_alternate config (--config .../htex_local_alternate.py)
	pip3 install ".[monitoring]"
	pytest parsl/tests/ -k "not cleannet" --config parsl/tests/configs/htex_local_alternate.py --random-order --durations 10

.PHONY: vineex_local_test
vineex_local_test:  ## Run the VineExecutor local tests (-k taskvine --config local)
	pytest parsl/tests/ -k "not cleannet" --config parsl/tests/configs/taskvine_ex.py --random-order --durations 10
	pytest parsl/tests/ -k "not cleannet and taskvine" --config local --random-order --durations 10

.PHONY: wqex_local_test
wqex_local_test:  ## Run the WorkQueueExecutor local tests (-k workqueue --config local)
	pytest parsl/tests/ -k "not cleannet" --config parsl/tests/configs/workqueue_ex.py --random-order --durations 10
	pytest parsl/tests/ -k "not cleannet and workqueue" --config local --random-order --durations 10

.PHONY: radical_local_test
radical_local_test:  ## Run the Radical local tests (-m radical --config local)
	pip3 install ".[radical-pilot]"
	mkdir -p ~/.radical/pilot/configs && echo '{"localhost": {"virtenv_mode": "local"}}' > ~/.radical/pilot/configs/resource_local.json
	pytest parsl/tests/ -k "not cleannet and not issue3328 and not executor_supports_std_stream_tuples" --config parsl/tests/configs/local_radical.py --random-order --durations 10
	pytest parsl/tests/ -m "radical" --config local --random-order --durations 10

.PHONY: config_local_test
config_local_test:  ## run the config-local tests (--config local)
	pip3 install ".[monitoring,visualization,proxystore,kubernetes]"
	pytest parsl/tests/ -k "not cleannet and not workqueue and not taskvine and not globus_compute" --config local --random-order --durations 10

.PHONY: site_test
site_test:  ## Run the site tests
	pytest parsl/tests/ -k "not cleannet" ${SHARED_FS_OPTIONS} --config parsl/tests/site_tests/site_config_selector.py --random-order
	pytest parsl/tests/site_tests/ ${SHARED_FS_OPTIONS} --config local

.PHONY: perf_test
perf_test:  ## Run `parsl-perf` (--config .../local_threads.py)
	parsl-perf --time 5 --config parsl/tests/configs/local_threads.py
	parsl-perf --iterate 1,2,3 --config parsl/tests/configs/local_threads.py

.PHONY: test ## run all tests with all config types
test: clean_coverage isort lint flake8 mypy local_thread_test htex_local_test htex_local_alternate_test config_local_test perf_test ## run all tests

.PHONY: tag
tag: ## create a tag in git. to run, do a 'make VERSION="version string" tag
	./tag_and_release.sh create_tag $(VERSION)

.PHONY: package
package: ## package up a distribution.
	./tag_and_release.sh package

.PHONY: deploy
deploy: ## deploy the distribution
	./tag_and_release.sh release

# THIS IS MEANT TO BE INVOKED BY GITHUB ACTIONS **ONLY**
.PHONY: update_version
update_version: ## Update version
	./tag_and_release.sh update_version

.PHONY: release
release: deps tag package deploy   ## create a release. To run, do a 'make VERSION="version string"  release'

.PHONY: coverage
coverage: ## show the coverage report
	# coverage report
	echo no-op coverage report

.PHONY: clean
clean: ## clean up the environment by deleting the .venv, dist, eggs, mypy caches, coverage info, etc
	rm -rf .venv $(DEPS) dist *.egg-info .mypy_cache build .pytest_cache .coverage runinfo $(WORKQUEUE_INSTALL)

.PHONY: flux_local_test
flux_local_test: ## Test Parsl with Flux Executor
	pip3 install .
	pytest parsl/tests/ -k "not cleannet" --config parsl/tests/configs/flux_local.py --random-order --durations 10

=== debian/changelog ===
python-parsl (2025.11.17+ds-1) unstable; urgency=medium

  * New upstream version 2025.11.17+ds

 -- Étienne Mollier <emollier@debian.org>  Tue, 18 Nov 2025 21:20:07 +0100

## python-parsl 2025.12.01+ds

=== debian/changelog ===
python-parsl (2025.12.01+ds-1) unstable; urgency=medium

  * New upstream version 2025.12.01+ds

 -- Étienne Mollier <emollier@debian.org>  Tue, 02 Dec 2025 21:37:59 +0100

## python-parsl 2025.12.08+ds

=== debian/changelog ===
python-parsl (2025.12.08+ds-1) unstable; urgency=medium

  * New upstream version 2025.12.08+ds

 -- Étienne Mollier <emollier@debian.org>  Thu, 11 Dec 2025 01:19:32 +0100

## python-parsl 2025.12.15+ds

=== debian/changelog ===
python-parsl (2025.12.15+ds-1) unstable; urgency=medium

  * New upstream version 2025.12.15+ds
  * pytest-9.patch: new: fix conftest failure. (Closes: #1123284)

 -- Étienne Mollier <emollier@debian.org>  Fri, 19 Dec 2025 21:26:50 +0100

## python-parsl 2026.01.05+ds

=== debian/changelog ===
python-parsl (2026.01.05+ds-1) unstable; urgency=medium

  * New upstream version 2026.01.05+ds
  * d/control: drop redundant Priority: optional.
  * d/control: declare compliance to standards version 4.7.3.

 -- Étienne Mollier <emollier@debian.org>  Tue, 06 Jan 2026 20:18:43 +0100

=== debian/control ===
Source: python-parsl
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Étienne Mollier <emollier@debian.org>
Section: python
Testsuite: autopkgtest-pkg-pybuild
Build-Depends: debhelper-compat (= 13),
               dh-sequence-python3,
               dh-sequence-sphinxdoc,
               pybuild-plugin-pyproject,
               python3-all,
               python3-setuptools,
               help2man <!nodoc>,
               python3-filelock <!nocheck> <!nodoc>,
               python3-flask <!nodoc>,
               python3-flask-sqlalchemy <!nodoc>,
               mypy <!nocheck>,
               mpich <!nocheck>,
               python3-dill <!nocheck> <!nodoc>,
               python3-globus-sdk <!nocheck> <!nodoc>,
               python3-mypy <!nocheck>,
               python3-mypy-extensions <!nocheck>,
               python3-nbsphinx <!nocheck> <!nodoc>,
               python3-pandas <!nocheck>,
               python3-paramiko <!nocheck> <!nodoc>,
               python3-psutil <!nocheck> <!nodoc>,
               python3-pytest <!nocheck>,
               python3-pytest-random-order <!nocheck>,
               python3-requests <!nocheck> <!nodoc>,
               python3-setproctitle <!nocheck>,
               python3-sortedcontainers <!nocheck>,
               python3-sphinx-rtd-theme <!nocheck> <!nodoc>,
               python3-sqlalchemy <!nocheck>,
               python3-typeguard <!nocheck> <!nodoc>,
               python3-typing-extensions <!nocheck>,
               python3-typing-inspect <!nocheck>,
               python3-typeshed <!nocheck>,
               python3-tblib <!nocheck> <!nodoc>,
               python3-zmq <!nocheck> <!nodoc>,
               twine <!nocheck>
Standards-Version: 4.7.3
Homepage: https://github.com/Parsl/parsl
Vcs-Git: https://salsa.debian.org/python-team/packages/python-parsl.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/python-parsl.git

Package: python3-parsl
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends},
         libjs-bootstrap4,
         libjs-jquery,
         libjs-popper.js,
         node-fortawesome-fontawesome-free,
         python3-flask,
         python3-flask-sqlalchemy
# Provider for plotly-latest.min.js; not ideal but better than nothing.
# FIXME: a package with standalone plotly-latest.min.js would be nice.
Recommends: r-cran-plotly
Description: Parallel Scripting Library for Python
 Parsl extends parallelism in Python beyond a single computer.
 .
 One can use Parsl just like Python's parallel executors but across multiple
 cores and nodes. However, the real power of Parsl is in expressing multi-step
 workflows of functions. Parsl lets one chain functions together and will
 launch each function as inputs and computing resources are available.

Package: python-parsl-doc
Architecture: all
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         python3-parsl,
         libjs-requirejs
Section: doc
Description: Parallel Scripting Library for Python - documentation
 Parsl extends parallelism in Python beyond a single computer.
 .
 One can use Parsl just like Python's parallel executors but across multiple
 cores and nodes. However, the real power of Parsl is in expressing multi-step
 workflows of functions. Parsl lets one chain functions together and will
 launch each function as inputs and computing resources are available.
 .
 This package provides a locally readable Parsl documentation.

## python-parsl 2026.01.19+ds

=== debian/changelog ===
python-parsl (2026.01.19+ds-1) unstable; urgency=medium

  * New upstream version 2026.01.19+ds
  * pytest-9.patch: fix typo caught by lintian in the Description.
  * pytest-9.patch: forwarded upstream.

 -- Étienne Mollier <emollier@debian.org>  Tue, 20 Jan 2026 19:28:48 +0100

## python-parsl 2026.01.26+ds

=== debian/changelog ===
python-parsl (2026.01.26+ds-1) unstable; urgency=medium

  * New upstream version 2026.01.26+ds

 -- Étienne Mollier <emollier@debian.org>  Tue, 27 Jan 2026 21:19:31 +0100

## python-parsl 2026.02.09+ds

=== debian/changelog ===
python-parsl (2026.02.09+ds-1) unstable; urgency=medium

  * New upstream version 2026.02.09+ds

 -- Étienne Mollier <emollier@debian.org>  Tue, 10 Feb 2026 20:15:06 +0100

## python-parsl 2026.02.23+ds

=== debian/changelog ===
python-parsl (2026.02.23+ds-1) unstable; urgency=medium

  * New upstream version 2026.02.23+ds

 -- Étienne Mollier <emollier@debian.org>  Tue, 24 Feb 2026 22:27:41 +0100
